DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Time Zone Support

The JavaScript Scheduler allows its users to view appointments in different time zones. Set the timeZone property to specify the current time zone. This property accepts values from the IANA time zone database.

In this demo, you can use the drop-down menu above the JavaScript Scheduler to choose between the London, Berlin, and Helsinki time zones. To populate the menu, the getTimeZones utility method is used. It returns a list of all IANA time zones that is then filtered.

Backend API
$(() => { const currentDate = new Date(2021, 3, 27); const getTimeZones = function (date) { const timeZones = DevExpress.utils.getTimeZones(date); return timeZones.filter((timeZone) => locations.indexOf(timeZone.id) !== -1); }; const timeZones = getTimeZones(currentDate); const scheduler = $('#scheduler').dxScheduler({ dataSource: data, views: ['workWeek'], timeZone: timeZones[0].id, currentView: 'workWeek', currentDate, startDayHour: 8, height: 600, editing: { allowTimeZoneEditing: true, }, onOptionChanged(e) { if (e.name === 'currentDate') { locationSwitcher.option('items', getTimeZones(e.value)); } }, onAppointmentFormOpening(e) { const { form } = e; const startDateTimezoneEditor = form.getEditor('startDateTimeZone'); const endDateTimezoneEditor = form.getEditor('endDateTimeZone'); const startDateDataSource = startDateTimezoneEditor.option('dataSource'); const endDateDataSource = endDateTimezoneEditor.option('dataSource'); startDateDataSource.filter(['id', 'contains', 'Europe']); endDateDataSource.filter(['id', 'contains', 'Europe']); startDateDataSource.load(); endDateDataSource.load(); }, }).dxScheduler('instance'); const locationSwitcher = $('#location-switcher').dxSelectBox({ items: timeZones, displayExpr: 'title', inputAttr: { 'aria-label': 'Time zone' }, valueExpr: 'id', width: 240, value: timeZones[0].id, onValueChanged(data) { scheduler.option('timeZone', data.value); }, }).dxSelectBox('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="option"> <span>Office Time Zone</span> <div id="location-switcher"></div> </div> <div id="scheduler"></div> </div> </body> </html>
.option { display: flex; } .option > span { display: flex; align-items: center; margin-right: 10px; } .dx-scheduler { margin-top: 20px; }
const data = [ { text: 'Stand-up meeting', startDate: '2021-04-26T15:30:00.000Z', endDate: '2021-04-26T15:45:00.000Z', recurrenceRule: 'FREQ=DAILY', }, { text: 'Book Flights to San Fran for Sales Trip', startDate: '2021-04-28T18:00:00.000Z', endDate: '2021-04-28T19:00:00.000Z', }, { text: 'New Brochures', startDate: '2021-04-30T18:30:00.000Z', endDate: '2021-04-30T18:45:00.000Z', }, { text: 'Website Re-Design Plan', startDate: '2021-04-27T12:30:00.000Z', endDate: '2021-04-27T13:30:00.000Z', }, { text: 'Book Flights to San Fran for Sales Trip', startDate: '2021-04-28T16:00:00.000Z', endDate: '2021-04-28T15:00:00.000Z', }, { text: 'Prepare 2021 Marketing Plan', startDate: '2021-04-26T07:00:00.000Z', endDate: '2021-04-26T09:30:00.000Z', }, { text: 'Launch New Website', startDate: '2021-04-28T08:00:00.000Z', endDate: '2021-04-28T10:00:00.000Z', }, { text: 'Submit New Website Design', startDate: '2021-04-29T09:30:00.000Z', endDate: '2021-04-29T11:00:00.000Z', }, { text: 'Upgrade Server Hardware', startDate: '2021-04-30T06:30:00.000Z', endDate: '2021-04-30T08:00:00.000Z', }, { text: 'Approve New Online Marketing Strategy', startDate: '2021-04-30T11:00:00.000Z', endDate: '2021-04-30T12:30:00.000Z', }, { text: 'Final Budget Review', startDate: '2021-04-27T09:00:00.000Z', endDate: '2021-04-27T10:35:00.000Z', }]; const locations = ['Europe/London', 'Europe/Berlin', 'Europe/Helsinki'];

Users can edit the time zones of individual appointments in the appointment details form. To enable this functionality, set the editing.allowTimeZoneEditing property to true. Information about individual time zones is saved in the startDateTimeZone and endDateTimeZone fields of the appointment data objects.

Backend API
<template>
<div>
<div class="option">
<span>Office Time Zone</span>
<DxSelectBox
:items="timeZones"
v-model:value="currentTimeZone"
:input-attr="{ 'aria-label': 'Time zone' }"
:width="240"
display-expr="title"
value-expr="id"
/>
</div>
<DxScheduler
:data-source="dataSource"
:current-date="currentDate"
:views="views"
:height="600"
:start-day-hour="8"
:time-zone="currentTimeZone"
current-view="workWeek"
:on-appointment-form-opening="onAppointmentFormOpening"
:on-option-changed="onOptionChanged"
>
<DxEditing
:allow-time-zone-editing="true"
/>
</DxScheduler>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxScheduler, { DxEditing, type DxSchedulerTypes } from 'devextreme-vue/scheduler';
import DxSelectBox from 'devextreme-vue/select-box';
import { getTimeZones as getTimeZonesUtility } from 'devextreme/time_zone_utils';
import { DataSource } from 'devextreme-vue/common/data';
import { data, locations } from './data.ts';
const views = ['workWeek'];
const dataSource = data;
const currentDate = new Date(2021, 3, 27);
const getTimeZones = (date: Date) => getTimeZonesUtility(date, locations);
const timeZones = ref(getTimeZones(currentDate));
const currentTimeZone = ref(timeZones.value[0].id);
function onAppointmentFormOpening(args: DxSchedulerTypes.AppointmentFormOpeningEvent) {
const { form } = args;
const startDateTimezoneEditor = form.getEditor('startDateTimeZone');
const endDateTimezoneEditor = form.getEditor('endDateTimeZone');
const startDateDataSource = startDateTimezoneEditor?.option('dataSource') as DataSource;
const endDateDataSource = endDateTimezoneEditor?.option('dataSource') as DataSource;
startDateDataSource.filter(['id', 'contains', 'Europe']);
endDateDataSource.filter(['id', 'contains', 'Europe']);
startDateDataSource.load();
endDateDataSource.load();
}
function onOptionChanged(args: DxSchedulerTypes.OptionChangedEvent) {
if (args.name === 'currentDate') {
timeZones.value = getTimeZones(args.value);
}
}
</script>
<style scoped>
.option {
display: flex;
}
.option > span {
display: flex;
align-items: center;
margin-right: 10px;
}
.dx-scheduler {
margin-top: 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'project:utils/demo-vue-loader.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const data = [
{
text: 'Stand-up meeting',
startDate: '2021-04-26T15:30:00.000Z',
endDate: '2021-04-26T15:45:00.000Z',
recurrenceRule: 'FREQ=DAILY',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T18:00:00.000Z',
endDate: '2021-04-28T19:00:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-30T18:30:00.000Z',
endDate: '2021-04-30T18:45:00.000Z',
}, {
text: 'Website Re-Design Plan',
startDate: '2021-04-27T12:30:00.000Z',
endDate: '2021-04-27T13:30:00.000Z',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T16:00:00.000Z',
endDate: '2021-04-28T15:00:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-26T07:00:00.000Z',
endDate: '2021-04-26T09:30:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-28T08:00:00.000Z',
endDate: '2021-04-28T10:00:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-29T09:30:00.000Z',
endDate: '2021-04-29T11:00:00.000Z',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-04-30T06:30:00.000Z',
endDate: '2021-04-30T08:00:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-04-30T11:00:00.000Z',
endDate: '2021-04-30T12:30:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-04-27T09:00:00.000Z',
endDate: '2021-04-27T10:35:00.000Z',
},
];
export const locations = ['Europe/London', 'Europe/Berlin', 'Europe/Helsinki'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
To define the time zone at the component level, assign an IANA time zone value to the timeZone property.
To modify time zones used for appointments, enable the editing.allowTimeZoneEditing option. Our Scheduler supports different time zones for appointment start and end dates (startDateTimeZone and endDateTimeZone appointment properties).

Backend API
<div class="option">
<span>Office Time Zone</span>
<dx-select-box
[items]="timeZones"
[width]="240"
[inputAttr]="{ 'aria-label': 'Location' }"
displayExpr="title"
valueExpr="id"
[(value)]="currentTimeZone"
>
</dx-select-box>
</div>
<dx-scheduler
[dataSource]="dataSource"
[timeZone]="currentTimeZone"
[views]="['workWeek']"
currentView="workWeek"
[currentDate]="currentDate"
[height]="600"
[startDayHour]="8"
(onAppointmentFormOpening)="onAppointmentFormOpening($event)"
(onOptionChanged)="onOptionChanged($event)"
>
<dxo-scheduler-editing [allowTimeZoneEditing]="true"> </dxo-scheduler-editing>
</dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule, DxSelectBoxModule } from 'devextreme-angular';
import { getTimeZones, dxSchedulerTimeZone } from 'devextreme/time_zone_utils';
import { DxSchedulerTypes } from 'devextreme-angular/ui/scheduler';
import { DataSource } from 'devextreme-angular/common/data';
import { Service, Data } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxSchedulerModule,
DxSelectBoxModule,
],
})
export class AppComponent {
locations: string[];
dataSource: Data[];
service: Service;
currentDate: Date = new Date(2021, 3, 27);
timeZones: dxSchedulerTimeZone[] = [];
currentTimeZone = '';
constructor(service: Service) {
this.service = service;
this.dataSource = service.getData();
this.timeZones = this.getDefaultTimeZones(this.currentDate);
this.currentTimeZone = this.timeZones[0].id;
}
getDefaultTimeZones = (date: Date) => getTimeZones(date, this.service.getLocations());
onAppointmentFormOpening({ form }: DxSchedulerTypes.AppointmentFormOpeningEvent) {
const startDateDataSource = form.getEditor('startDateTimeZone').option('dataSource') as DataSource;
const endDateDataSource = form.getEditor('endDateTimeZone').option('dataSource') as DataSource;
startDateDataSource.filter(['id', 'contains', 'Europe']);
endDateDataSource.filter(['id', 'contains', 'Europe']);
startDateDataSource.load();
endDateDataSource.load();
}
onOptionChanged({ name, value }: DxSchedulerTypes.OptionChangedEvent) {
if (name === 'currentDate') {
this.timeZones = this.getDefaultTimeZones(value);
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.option {
display: flex;
}
.option > span {
display: flex;
align-items: center;
margin-right: 10px;
}
::ng-deep .dx-scheduler {
margin-top: 20px;
}
import { Injectable } from '@angular/core';
export class Data {
text: string;
startDate: string;
endDate: string;
recurrenceRule?: string;
}
export class Location {
id: string;
offset: number;
title: string;
}
export const data: Data[] = [{
text: 'Stand-up meeting',
startDate: '2021-04-26T15:30:00.000Z',
endDate: '2021-04-26T15:45:00.000Z',
recurrenceRule: 'FREQ=DAILY',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T18:00:00.000Z',
endDate: '2021-04-28T19:00:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-30T18:30:00.000Z',
endDate: '2021-04-30T18:45:00.000Z',
}, {
text: 'Website Re-Design Plan',
startDate: '2021-04-27T12:30:00.000Z',
endDate: '2021-04-27T13:30:00.000Z',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T16:00:00.000Z',
endDate: '2021-04-28T15:00:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-26T07:00:00.000Z',
endDate: '2021-04-26T09:30:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-28T08:00:00.000Z',
endDate: '2021-04-28T10:00:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-29T09:30:00.000Z',
endDate: '2021-04-29T11:00:00.000Z',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-04-30T06:30:00.000Z',
endDate: '2021-04-30T08:00:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-04-30T11:00:00.000Z',
endDate: '2021-04-30T12:30:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-04-27T09:00:00.000Z',
endDate: '2021-04-27T10:35:00.000Z',
}];
export const locations = ['Europe/London', 'Europe/Berlin', 'Europe/Helsinki'];
@Injectable()
export class Service {
getLocations() {
return locations;
}
getData() {
return data;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
To define the time zone at the component level, assign an IANA time zone value to the timeZone property.
To modify time zones used for appointments, enable the editing.allowTimeZoneEditing option. Our Scheduler supports different time zones for appointment start and end dates (startDateTimeZone and endDateTimeZone appointment properties).

Backend API
import React, { useCallback, useState } from 'react';
import Scheduler, { Editing } from 'devextreme-react/scheduler';
import SelectBox from 'devextreme-react/select-box';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import * as timeZoneUtils from 'devextreme/time_zone_utils';
import { data, locations } from './data.ts';
const timeZoneLabel = { 'aria-label': 'Time zone' };
const currentDate = new Date(2021, 3, 27);
const views: SchedulerTypes.ViewType[] = ['workWeek'];
const getTimeZones = (date: Date) => timeZoneUtils.getTimeZones(date, locations);
const defaultTimeZones = getTimeZones(currentDate);
const onAppointmentFormOpening = (e: SchedulerTypes.AppointmentFormOpeningEvent) => {
const { form } = e;
const startDateTimezoneEditor = form.getEditor('startDateTimeZone');
const endDateTimezoneEditor = form.getEditor('endDateTimeZone');
const startDateDataSource = startDateTimezoneEditor?.option('dataSource') as any;
const endDateDataSource = endDateTimezoneEditor?.option('dataSource') as any;
startDateDataSource.filter(['id', 'contains', 'Europe']);
endDateDataSource.filter(['id', 'contains', 'Europe']);
startDateDataSource.load();
endDateDataSource.load();
};
const App = () => {
const [currentTimeZone, setCurrentTimeZone] = useState(defaultTimeZones[0].id);
const [timeZones, setTimeZones] = useState(defaultTimeZones);
const onValueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
setCurrentTimeZone(e.value);
}, []);
const onOptionChanged = useCallback((e: SchedulerTypes.OptionChangedEvent) => {
if (e.name === 'currentDate') {
setTimeZones(getTimeZones(e.value));
}
}, []);
return (
<>
<div className="option">
<span>Office Time Zone</span>
<SelectBox
items={timeZones}
displayExpr="title"
valueExpr="id"
inputAttr={timeZoneLabel}
width={240}
value={currentTimeZone}
onValueChanged={onValueChanged}
/>
</div>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="workWeek"
startDayHour={8}
defaultCurrentDate={currentDate}
timeZone={currentTimeZone}
height={600}
onAppointmentFormOpening={onAppointmentFormOpening}
onOptionChanged={onOptionChanged}
>
<Editing allowTimeZoneEditing={true} />
</Scheduler>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Scheduler, { Editing } from 'devextreme-react/scheduler';
import SelectBox from 'devextreme-react/select-box';
import * as timeZoneUtils from 'devextreme/time_zone_utils';
import { data, locations } from './data.js';
const timeZoneLabel = { 'aria-label': 'Time zone' };
const currentDate = new Date(2021, 3, 27);
const views = ['workWeek'];
const getTimeZones = (date) => timeZoneUtils.getTimeZones(date, locations);
const defaultTimeZones = getTimeZones(currentDate);
const onAppointmentFormOpening = (e) => {
const { form } = e;
const startDateTimezoneEditor = form.getEditor('startDateTimeZone');
const endDateTimezoneEditor = form.getEditor('endDateTimeZone');
const startDateDataSource = startDateTimezoneEditor?.option('dataSource');
const endDateDataSource = endDateTimezoneEditor?.option('dataSource');
startDateDataSource.filter(['id', 'contains', 'Europe']);
endDateDataSource.filter(['id', 'contains', 'Europe']);
startDateDataSource.load();
endDateDataSource.load();
};
const App = () => {
const [currentTimeZone, setCurrentTimeZone] = useState(defaultTimeZones[0].id);
const [timeZones, setTimeZones] = useState(defaultTimeZones);
const onValueChanged = useCallback((e) => {
setCurrentTimeZone(e.value);
}, []);
const onOptionChanged = useCallback((e) => {
if (e.name === 'currentDate') {
setTimeZones(getTimeZones(e.value));
}
}, []);
return (
<>
<div className="option">
<span>Office Time Zone</span>
<SelectBox
items={timeZones}
displayExpr="title"
valueExpr="id"
inputAttr={timeZoneLabel}
width={240}
value={currentTimeZone}
onValueChanged={onValueChanged}
/>
</div>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="workWeek"
startDayHour={8}
defaultCurrentDate={currentDate}
timeZone={currentTimeZone}
height={600}
onAppointmentFormOpening={onAppointmentFormOpening}
onOptionChanged={onOptionChanged}
>
<Editing allowTimeZoneEditing={true} />
</Scheduler>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
export const data: SchedulerTypes.Appointment[] = [
{
text: 'Stand-up meeting',
startDate: '2021-04-26T15:30:00.000Z',
endDate: '2021-04-26T15:45:00.000Z',
recurrenceRule: 'FREQ=DAILY',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T18:00:00.000Z',
endDate: '2021-04-28T19:00:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-30T18:30:00.000Z',
endDate: '2021-04-30T18:45:00.000Z',
}, {
text: 'Website Re-Design Plan',
startDate: '2021-04-27T12:30:00.000Z',
endDate: '2021-04-27T13:30:00.000Z',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T16:00:00.000Z',
endDate: '2021-04-28T15:00:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-26T07:00:00.000Z',
endDate: '2021-04-26T09:30:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-28T08:00:00.000Z',
endDate: '2021-04-28T10:00:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-29T09:30:00.000Z',
endDate: '2021-04-29T11:00:00.000Z',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-04-30T06:30:00.000Z',
endDate: '2021-04-30T08:00:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-04-30T11:00:00.000Z',
endDate: '2021-04-30T12:30:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-04-27T09:00:00.000Z',
endDate: '2021-04-27T10:35:00.000Z',
},
];
export const locations = ['Europe/London', 'Europe/Berlin', 'Europe/Helsinki'];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
text: 'Stand-up meeting',
startDate: '2021-04-26T15:30:00.000Z',
endDate: '2021-04-26T15:45:00.000Z',
recurrenceRule: 'FREQ=DAILY',
},
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T18:00:00.000Z',
endDate: '2021-04-28T19:00:00.000Z',
},
{
text: 'New Brochures',
startDate: '2021-04-30T18:30:00.000Z',
endDate: '2021-04-30T18:45:00.000Z',
},
{
text: 'Website Re-Design Plan',
startDate: '2021-04-27T12:30:00.000Z',
endDate: '2021-04-27T13:30:00.000Z',
},
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: '2021-04-28T16:00:00.000Z',
endDate: '2021-04-28T15:00:00.000Z',
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-26T07:00:00.000Z',
endDate: '2021-04-26T09:30:00.000Z',
},
{
text: 'Launch New Website',
startDate: '2021-04-28T08:00:00.000Z',
endDate: '2021-04-28T10:00:00.000Z',
},
{
text: 'Submit New Website Design',
startDate: '2021-04-29T09:30:00.000Z',
endDate: '2021-04-29T11:00:00.000Z',
},
{
text: 'Upgrade Server Hardware',
startDate: '2021-04-30T06:30:00.000Z',
endDate: '2021-04-30T08:00:00.000Z',
},
{
text: 'Approve New Online Marketing Strategy',
startDate: '2021-04-30T11:00:00.000Z',
endDate: '2021-04-30T12:30:00.000Z',
},
{
text: 'Final Budget Review',
startDate: '2021-04-27T09:00:00.000Z',
endDate: '2021-04-27T10:35:00.000Z',
},
];
export const locations = ['Europe/London', 'Europe/Berlin', 'Europe/Helsinki'];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.option {
display: flex;
}
.option > span {
display: flex;
align-items: center;
margin-right: 10px;
}
.dx-scheduler {
margin-top: 20px;
}
To define the time zone at the component level, assign an IANA time zone value to the timeZone property.
To modify time zones used for appointments, enable the editing.allowTimeZoneEditing option. Our Scheduler supports different time zones for appointment start and end dates (startDateTimeZone and endDateTimeZone appointment properties).